#include "Microstrip.h"

extern PegBitmap gbimatgeBitmap;

Microstrip::Microstrip(PegRect rect, CPMainFrame* frame):CPModuleWindow(rect,0,0,frame)
{
init();
}

int Microstrip::init()
{   
   	const WORD wStyle = FF_NONE|TJ_LEFT|AF_TRANSPARENT| TT_COPY;
	const SIGNED margin = 5;
	const SIGNED width=mClient.Width()-2*margin;
 
    PEGCHAR* chrepsilon = "\xEC\xA0"; 
    PEGCHAR* chrmu = "\xED\x72"; 

    PegRect rectangle;
 
 	PegPrompt* label5 = new PegPrompt(margin, 80, width/2, "W("+CPString(chrmu)+"m):",0,wStyle);
	W = new CPPegString(margin+41,80,30,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(W);
	AddR(label5);

/*
 	PegPrompt* label4 = new PegPrompt(margin+width/2+7, 80, width/2, "L("+CPString(chrmu)+"m):",0,wStyle);
	L = new CPPegString(margin+width/2+46,80,30,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(L);
	AddR(label4);
*/

 	PegPrompt* label = new PegPrompt(margin, 95, width/2, "T("+CPString(chrmu)+"m):",0,wStyle);
	T = new CPPegString(margin+41,95,30,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(T);
	AddR(label);
	
    
   	PegPrompt* label2 = new PegPrompt(margin+width/2+7, 80, width/2, "H("+CPString(chrmu)+"m):",0,wStyle);
	H = new CPPegString(margin+width/2+46,80,30,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(H);
	AddR(label2);
    
 
   	PegPrompt* label3 = new PegPrompt(margin+width/2+7, 95, width/2, CPString(chrepsilon)+"r:",0,wStyle);
	er  = new CPPegString(margin+width/2+46,95,30,"",0, FF_THIN|AF_ENABLED|EF_EDIT);
	AddR(er);
	AddR(label3);
    
    //rectangle.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_BOTTOM);
    rectangle.Set(25, 115, 90, 130);
   	PegTextButton* b3 = new PegTextButton(rectangle, "Calcular!", BOTO, AF_ENABLED|TJ_CENTER);
	AddR(b3);
	
    rectangle.Set(MAINFRAME_LEFT, MAINFRAME_TOP, MAINFRAME_RIGHT, MAINFRAME_TOP+75);
 	PegBitmapButton * imatge = new PegBitmapButton(rectangle,&gbimatgeBitmap,0,AF_TRANSPARENT,TYPE_PROMPT,FALSE);
 	AddR(imatge); 
 	
 	res1 = new PegPrompt(margin, 135, width, "",0,wStyle);
 	res2 = new PegPrompt(margin, 150, width, "",0,wStyle);
   	res3 = new PegPrompt(margin, 165, width, "",0,wStyle);
   	res4 = new PegPrompt(margin, 180, width, "",0,wStyle);
 	AddR(res1);
	AddR(res2);
	AddR(res3);
	AddR(res4);
	
	return 0;
}

void Microstrip::Draw()
{
	BeginDraw();
	Invalidate(mClient);
	DrawFrame();
	DrawChildren();
	EndDraw();
}

SIGNED Microstrip::Message(const PegMessage &Mesg)
{
	switch(Mesg.wType)
	{
		case SIGNAL(BOTO, PSF_CLICKED):
		{
             Calcula();
		}
		break;
		
		default:
		return CPModuleWindow::Message(Mesg);
	}
	return 0;
}

WORD Microstrip::Dialog(char* title, char* message)
{
	PegRect rr = GetMainFrame()->TopAppRectangle();
	rr.wBottom -= 30;
	rr.wRight -= 10;
	rr.wTop += 10;
	rr.wLeft += 10;
	PegMessageWindow *msg = new PegMessageWindow(rr, title, message, MW_OK, 0,0,0);
	return msg->Execute();
}

void Microstrip::Calcula()
{
    OBCD aux,aux2,aux3;
    PEGCHAR* chrohm = "\xEC\x7E"; 

    ExecuteToOBCD("1.41",aux);
    aux2 = CPExpression(er->DataGet());
    Cal_add_OBC(&aux,&aux2);
    Cal_sqrt_OBC(&aux);
    ExecuteToOBCD("87",aux2);
    Cal_div_OBC(&aux2,&aux);
    
    ExecuteToOBCD("0.8",aux);
    aux3 = CPExpression(W->DataGet());
    Cal_mul_OBC(&aux,&aux3);
    aux3 = CPExpression(T->DataGet());
    Cal_add_OBC(&aux,&aux3);
    ExecuteToOBCD("5.98",aux3);
    Cal_div_OBC(&aux3,&aux);
    aux = CPExpression(H->DataGet());
    Cal_mul_OBC(&aux3,&aux);
    Cal_log_OBC(&aux3);
    
    Cal_mul_OBC(&aux2,&aux3);
    Zo = aux2;
    
    ExecuteToOBCD("100",aux);
    Cal_mul_OBC(&aux2,&aux);
    Cal_cint_OBC(&aux2);
    Cal_div_OBC(&aux2,&aux);
   
    res1->DataSet("Zo = "+CPString(aux2)+" "+CPString(chrohm));
    
    ExecuteToOBCD("1.41",aux);
    aux2 = CPExpression(er->DataGet());
    Cal_add_OBC(&aux,&aux2);
    Cal_div_OBC(&aux,&aux3);
    ExecuteToOBCD("0.67",aux2);
    Cal_mul_OBC(&aux,&aux2);
 
    ExecuteToOBCD("2.54",aux2);
    Cal_div_OBC(&aux,&aux2);
    
    Co = aux;
    
    ExecuteToOBCD("1000",aux2);
    Cal_mul_OBC(&aux,&aux2);
    Cal_cint_OBC(&aux);
    ExecuteToOBCD("1000",aux2);
    Cal_div_OBC(&aux,&aux2);
 
    res2->DataSet("Co = "+CPString(aux)+" pF/cm");
  
    aux = Co;
    Cal_mul_OBC(&aux,&Zo);
    Cal_mul_OBC(&aux,&Zo);

    Lo = aux;
    
    Cal_cint_OBC(&aux);
    ExecuteToOBCD("1000",aux2);
    Cal_div_OBC(&aux,&aux2);

    res3->DataSet("Lo = "+CPString(aux)+" nH/cm");
    
    aux = CPExpression(er->DataGet());
    ExecuteToOBCD("0.475",aux2);
    Cal_mul_OBC(&aux,&aux2);
    ExecuteToOBCD("0.67",aux2);
    Cal_add_OBC(&aux,&aux2);
    Cal_sqrt_OBC(&aux);
    ExecuteToOBCD("0.3",aux2);
    Cal_div_OBC(&aux,&aux2);
   
    Tpd = aux;
    
    ExecuteToOBCD("1000",aux2);
    Cal_mul_OBC(&aux,&aux2);
    Cal_cint_OBC(&aux);
    ExecuteToOBCD("1000",aux2);
    Cal_div_OBC(&aux,&aux2);
 
    res4->DataSet("Tpd = "+CPString(aux)+" ns/m");

    Draw();
}   

extern "C" char *ExtensionGetLang(ID_MESSAGE MessageNo)
{
return "";
}
